uniform mat4 uMVPMatrix;

const float cUVTZScaleFactor = 255.0;
const float cOffTheScreenParticlePosition = 50000.0;

attribute vec2 aParticleVertex;
attribute vec2 aParticlePosition;

attribute vec2 aParticleTextureCoordinate;
attribute vec3 aUVT;

varying vec2 vParticleTextureCoordinate;
varying vec2 vPaletteTextureCoordinate;

void main() {
	vParticleTextureCoordinate = aParticleTextureCoordinate;
	vPaletteTextureCoordinate = vec2(aUVT.z / cUVTZScaleFactor, 0.0);

	vec2 particlePosition = aParticlePosition;
	if (aUVT.z < 0.0) {
        particlePosition.x = cOffTheScreenParticlePosition;
        particlePosition.y = cOffTheScreenParticlePosition;
	}

    float angle = atan(aUVT.x, aUVT.y);
    mat2 rotationMatrix = mat2(cos(angle), -sin(angle), sin(angle), cos(angle)); // columns are passed

    vec2 rotatedParticleVertex = rotationMatrix * aParticleVertex;

    vec4 particleVertex =  vec4(particlePosition.x + rotatedParticleVertex.x, particlePosition.y + rotatedParticleVertex.y, 0.0, 1.0);
    gl_Position = uMVPMatrix * particleVertex;
}